#!/bin/bash
#this probably requires linux shell tools: GNU cp,bash etc.
#i dont use non-linux unix, so this would need appropriate porting
#note this uses a lax a+rw chmodding policy for dirs to be writable by apache.
#You may have to do something different depending on your setup.


source allgroups.conf.sh
testconf

function usage() {
    cat <<EOF
USAGE:
  $0 path_of_new_group

I need to be run from within the code dir
I may clobber an existing installation.
EOF
exit
}

codedir=`dirname $0`
path="$1"
if [ "$1" = ""  ]; then usage; fi
groupname=`basename $path`
dbname=$groupname

while shift; do
    if [ "$1" == "-db" ]; then
        shift
        dbname=$1
    fi
done
files_to_copy="files filestore data"

#----------------------------------------------------------------------
echo "Creating dir $path"
mkdir -p $path

echo "Filling it with code symlinks..."
./updatelinks.sh  $path

for f in $files_to_copy; do
    rm -f $path/$f ##so real copies override symlinked ones
done

echo "Initializing files and data..."

cp -aup $files_to_copy $path

for f in $files_to_copy; do
    chmod a+rw $path/$f
done

cp conf.php.tmpl $path/conf.php

$path/data/restore-defaults.sh

chmod 666 $path/data/summary.inc

chmod 666 $path/data/linkstore.inc
#----------------------------------------------------------------------
echo  "Creating the database '$dbname'... "

echo "CREATE DATABASE \`$dbname\`" | $MYSQLCMD 

echo  "Filling the database  \`'$dbname'\`..."
$MYSQLCMD $dbname < group.skel.sql

echo "Updating the meta db with info..."
echo "INSERT groups SET name='$groupname', path_from_coderoot='$path'" | $MYSQLCMD $META_DBNAME

echo "Script finished."
echo "** Still need to edit the new conf.php to finish the install process!"
