<?
require_once "../common.php";
require_once "../lib/dbinit.php";
require_once "../lib/PodAuth.php";
require_once "../lib/group.php";
$a = new PodAuth();
$a->start();
$errorMsg = " ";
$guestsCanViewMAreas = SANDBOX;
if(!$a->isGroupOwner(GROUP_NAME)) {
  echo "You are not a valid group owner.";
  exit;
}
$db = dbinit_connect();
$metadb = dbinit_meta_connect();

function readInConf() {
  $fp = fopen("../conf.php", 'r');
  flock($fp, LOCK_SH);
  $confarray = file("../conf.php");
  flock($fp, LOCK_UN);
  fclose($fp);
  return $confarray;
}

function writeOutConf($confArray) {
  $fp = fopen("../conf.php", 'w');
  flock($fp, LOCK_EX);
  foreach($confArray as $line) {
    fwrite($fp, $line);
  }
  flock($fp, LOCK_UN);
  fclose($fp);
}

function changeSandbox($forceDisable) {
  $confArray = readInConf();
  for($i = 0; $i < count($confArray); $i++) {
    if(preg_match("/^define\(\"SANDBOX\",/", $confArray[$i])) {
      global $guestsCanViewMAreas, $db, $metadb;
      $q = "SELECT * FROM user_permissions
              WHERE groupname = '".GROUP_NAME."' 
              AND   BINARY username = 'guest'";
      
      $res = $metadb->query($q);
      if(DB::IsError($res)) {
	printr($res);
      }
      $guestIsMem = $res->numRows() > 0;
      if(SANDBOX) {
	$confArray[$i] = "define(\"SANDBOX\", false);\n";
	$guestsCanViewMAreas = false;
	if ($guestIsMem) leave_group('guest', $db, $metadb);
      } else {
	if (!$forceDisable) {
	  $confArray[$i] = "define(\"SANDBOX\", true);\n";
	  $guestsCanViewMAreas = true;
	  if (!$guestIsMem) join_group('guest', $db, $metadb);
	}
      }
    }
  }
  writeOutConf($confArray);
}

function addNewOwner($username) {
  global $metadb, $db;
  $q = "UPDATE user_permissions SET permission='owner' WHERE
        username='$username' AND groupname='".GROUP_NAME."'";
  $metadb->query($q);
  $q = "UPDATE users SET is_owner='1' WHERE username='$username'";
  $db->query($q);
}

function interceptErrors() {
  global $metadb, $errorMsg;
  if (isset($_REQUEST['newowner']) && $_REQUEST['newowner'] != "") {
    $q = "SELECT permission FROM user_permissions 
          WHERE groupname='".GROUP_NAME."' AND username='".$_REQUEST['newowner']."'";
    $res = $metadb->query($q);
    if ($res->numRows() == 0){
      $errorMsg = "<br> <b>ERROR:</b> The username you entered is not a member of this group.<br>";
      printDataEntry();
      exit;
    }
    $row = $res->fetchRow();
    if ($row['permission'] == 'owner'){
      $errorMsg = "<br> <b>ERROR:</b> The username you entered is already an owner of this group.<br>";
      printDataEntry();
      exit();
    }
  }
}

if(isset($_REQUEST['submit'])) {
  //Process submitted prefs.
  interceptErrors();
  $isDiffFromConf = SANDBOX != isset($_REQUEST['guests']);
  if ($_REQUEST['membership'] == 'anyone' && $isDiffFromConf) {
    //echo "is diff from conf";
    changeSandbox(false);
  }
  else if ($_REQUEST['membership'] != 'anyone') {
    //echo "disabled";
    if (SANDBOX) {
      changeSandbox(true);
    }
  } else if ( SANDBOX == isset($_REQUEST['guests'])){
    //echo "same";
  }
  if (isset($_REQUEST['newowner']) && $_REQUEST['newowner'] != "") {
    addNewOwner($_REQUEST['newowner']);
  }
  $isInviteOnly = $metadb->getOne("SELECT invite_only FROM groups WHERE name='".GROUP_NAME."'");
  if ($isInviteOnly && ($_REQUEST['membership'] == 'anyone')) {
    $metadb->query("UPDATE groups SET invite_only='0' WHERE name='".GROUP_NAME."'");
  } else if (!$isInviteOnly && ($_REQUEST['membership'] != 'anyone')) {
    $metadb->query("UPDATE groups SET invite_only='1' WHERE name='".GROUP_NAME."'");
  }
  displayResults();
} else {
  //Ask Two questions.
  printDataEntry();
}
function printDataEntry() {
  global $errorMsg;
  echo "
<html>
<head>
<title> Owner's Settings
</title>
</head>
<body>
<a href=\"..\">&lt;--- Back to Home</a>
$errorMsg
<form method=\"post\" action=\"".POD_URL_ROOT."/main/ownerprefs.php\">
<center>
<h1>Owner's Settings</h1>
<br><br>
<table border=0>
<tr><td colspan=\"2\" bgcolor=\"#FFFFCC\">Options:</td>
<td bgcolor=\"#eeeeee\">Additional Information:
</tr>
<tr>
<td>Which membership option do you prefer:</td>";
  global $metadb;
  $isInviteOnly = $metadb->getOne("SELECT invite_only FROM groups WHERE name='".GROUP_NAME."'"); 
  echo "<td><input type=\"radio\" name=\"membership\" value=\"anyone\"";
  if(!$isInviteOnly) echo " Checked";
  echo "> Anyone Can Join
<br><input type=\"radio\" name=\"membership\" value=\"invite\"";
  if($isInviteOnly) echo " Checked";
  echo "> Invite Only
</td>
<td>If you choose to require invitations for group membership then
then you must use the <a href=\"bulksubscribe.php\"> bulk subscription</a>
 feature to send out e-mail invitations to *all* invitees.  Note that the
bulk subscription feature can be used without requiring invitations.</td>
</tr>
<tr><td colspan=\"2\"><hr></td><td><hr></td></tr>
<tr>
<td>Check this box if you want to allow guests to view the meeting areas and other resources beyond the group homepage:</td>
<td><input type=\"checkbox\" name=\"guests\" ";
  if (SANDBOX){
    echo "checked=\"checked\"";
  }
  echo"></td>
<td>This feature will be disabled if membership is by invitation only.</td>
</tr>
<tr><td colspan=\"2\"><hr></td><td><hr></td></tr>
<tr>
<td>If you want to grant owner status to another user add his or her username here:</td>
<td><input type=\"text\" name=\"newowner\"></td>
<td>Groups can have multiple owners.</td>
</tr>
<tr><td colspan=\"2\" bgcolor=\"#FFFFCC\"><input type=\"submit\" name=\"submit\" value=\"submit\">
</td></tr>
</table></center>
<p>Note: These settings can be changed at anytime by selecting the \"owner's 
settings\" link from the group homepage.
</form></body></html>
";
}

function displayResults() {
  global $metadb;
  $q = "SELECT username FROM user_permissions WHERE 
        groupname='".GROUP_NAME."' AND 
        permission='owner'";
  $res = $metadb->query($q);
  echo "<html>
<head>
<title>Owner's Settings Updated 
</title>
</head>
<body>
<a href=\"..\">&lt;--- Back to Home</a><p>
<h1> Owner's Settings Updated </h1>
";
if ($res->numRows() > 1) {
  echo "<p><b>Owners of '". GROUP_LONGNAME."' are:</b> <ul>\n";
} else {
  echo "<p><b>The owner of '". GROUP_LONGNAME."' is:</b> <ul>\n";
}
  while ($row = $res->fetchRow()) {
    echo "<li>". $row['username']."</li>\n";
  }
echo "</ul>

<p>";
 $invite_only = $metadb->getOne("SELECT invite_only FROM groups WHERE name='".GROUP_NAME."'"); 
  if (!$invite_only) {
    echo "Membership to this group is open to anyone.<p>";
  } else {
    echo "Membership to this group is by invitation only.<br>
Go <a href=\"bulksubscribe.php\"> invite people to join</a> your group.<p>";
  }
 echo "Guests are "; 
 global $guestsCanViewMAreas;
 if (!$guestsCanViewMAreas) {
   echo "<b>not </b>";
 }
 echo "allowed to view meeting areas.";
 echo "</body>
</html>";
}
?>