#!/bin/bash
function usage() {
    cat <<EOF
USAGE:
  $0 path_of_existing_group [path_of_another and_another ...]

Must be run from within the code/ dir.

This script CAN be run over an existing installation, like if you
add new files to code/ or something.
EOF
    exit 0;
}

codedir=`pwd`

if [ "$1" == "" ]; then usage; fi

dirs_to_make="marea main lib lib/AuthContainer lib/DB"
files_to_link="
`find . $dirs_to_make -maxdepth 1 -regex '.*\.\(php\|html\|js\|css\|gif\|jpg\|jpeg\|png\|bmp\)$' -not -name '*.tmpl'` 

doc"

echo $files_to_link

LN_CMD="ln -ivs"
for path in $@; do
    if [ "$path" == "--copy" ]; then
        echo "** Copying not linking the code!"
        LN_CMD="cp -f"
    fi

    for d in $dirs_to_make; do
        mkdir -p $path/$d
    done

    find $path -type l \
                -not -path '*/files/*' -not -path '*/filestore/*' \
            -exec rm {} \;

    for ftl in $files_to_link; do
        $LN_CMD $codedir/$ftl $path/$ftl 
    done
done
